
import java.time.LocalDate;
import java.time.Period;

/**
 * Person of a social network.
 * 
 * @author Radek Oslejsek &lt;oslejsek@fi.muni.cz&gt;, Faculty of Informatics MU
 */
public class Person {
    
    public enum Sex {
        MALE, FEMALE
    }

    private String name; 
    private LocalDate birthday;
    private Sex gender;
    private String emailAddress;
   
    public Person(String name, LocalDate birthday, Sex gender, String mail) {
        this.name = name;
        this.birthday = birthday;
        this.gender = gender;
        this.emailAddress = mail;
    }  
 
    public int getAge() {
        return Period.between(birthday, LocalDate.now()).getYears();
    }
 
    public String getName() {
        return name;
    }
    
    public Sex getGender() {
        return gender;
    }
    
    public String getEmailAddress() {
        return emailAddress;
    }
    
    public void printPerson() {
        System.out.println(getName() + ": " + getAge());
    }
}
