
import java.time.LocalDate;
import java.util.Arrays;
import java.util.List;

public class Roster3 {
    
    public static void printPersons(List<Person> roster, CheckPerson tester) {
        for (Person p : roster) {
            if (tester.test(p)) {
                p.printPerson();
            }
        }
    }

    
    public static void main(String[] args) {
        List<Person> list = Arrays.asList(
                new Person("Pepa", LocalDate.of(1988, 10, 30), Person.Sex.MALE, "pepa@gmail.com"),
                new Person("Karel", LocalDate.of(1996, 8, 12), Person.Sex.MALE, "karel@gmail.com")
        );  
        
        printPersons(
            list, 
            new CheckPerson() { // anonymni trida
                public boolean test(Person p) {
                    return p.getAge() >= 18 &&
                        p.getAge() <= 25 &&
                        p.getGender() == Person.Sex.MALE;
                }
            }
        );
    }
}
