
import java.time.LocalDate;
import java.util.Arrays;
import java.util.List;
import java.util.function.*;

public class Roster7 {
    
    public static <X,Y> void printPersons(
        List<X> roster, 
        Predicate<X> tester,
        Function<X,Y> mapper,
        Consumer<Y> consumer
    ) {
        for (X p : roster) {
            if (tester.test(p)) {
                Y str = mapper.apply(p);
                consumer.accept(str);
            }
        }
    }

    
    public static void main(String[] args) {
        List<Person> list = Arrays.asList(
                new Person("Pepa", LocalDate.of(1988, 10, 30), Person.Sex.MALE, "pepa@gmail.com"),
                new Person("Karel", LocalDate.of(1996, 8, 12), Person.Sex.MALE, "karel@gmail.com")
        );  
        
        printPersons(
            list, 
            p ->
                p.getAge() >= 18 &&
                p.getAge() <= 25 &&
                p.getGender() == Person.Sex.MALE,
            p -> p.getEmailAddress(),
            mail -> System.out.println(mail)
        );
    }
}
